flask_book/models/entries.py
from flask_book import db
from datetime import datetime

class Entry(db.Model):
    __tablename__ = 'entries'
    id = db.Column(db.Integer, primary_key=True)
    title = db.Column(db.Text, unique=True)
    description = db.Column(db.Text)
    publisher = db.Column(db.Text)
    publisheddate = db.Column(db.Text)
    identifier10 = db.Column(db.Text)
    identifier13 = db.Column(db.Text)
    thumbnail = db.Column(db.Text)
    previewlink = db.Column(db.Text)
    tanto = db.Column(db.Text)
    hokan = db.Column(db.Text)
    memo = db.Column(db.Text)
    created_at = db.Column(db.DateTime)

    def __init__(self, title=None, description=None, publisher=None, publisheddate=None, identifier10=None, identifier13=None, thumbnail=None, previewlink=None, tanto=None, hokan=None, memo=None):
        self.title = title
        self.description = description
        self.publisher = publisher
        self.publisheddate = publisheddate
        self.identifier10 = identifier10
        self.identifier13 = identifier13
        self.thumbnail = thumbnail
        self.previewlink = previewlink
        self.tanto = tanto
        self.hokan = hokan
        self.memo = memo
        self.created_at = datetime.utcnow()

    def __repr__(self):
        return '<Entry id:{} title:{} description:{} publisher:{} publisheddate:{} identifier10:{} identifier13:{} thumbnail:{} previewlink:{} tanto:{} hokan:{} memo:{}>'.format(self.id, self.title, self.description, self.publisher, self.publisheddate, self.identifier10, self.identifier13, self.thumbnail, self.previewlink, self.tanto, self.hokan, self.memo)

flask_book/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy

app = Flask(__name__)
app.config.from_object('flask_book.config')

db = SQLAlchemy(app)

from flask_book.views.entries import entry

app.register_blueprint(entry, url_prefix='/list')

from flask_book.views import views

flask_book/views/entries.py
from flask import request, redirect, url_for, render_template, flash, session
from flask_book import app
from flask_book import db
from flask_book.models.entries import Entry
from flask_book.views.views import login_required
from flask import Blueprint
from flask_paginate import Pagination, get_page_parameter
import sys
import datetime
import requests
import json
from sqlalchemy import or_

entry = Blueprint('entry', __name__)

@entry.route('/')
@entry.route('/', defaults={'page': 1})
@entry.route('/<int:page>')
def show_entries():
    entries=Entry.query.order_by(Entry.id.desc()).all()
    return render_template('entries/index.html', entries=entries)


@entry.route('/', methods=['POST'])
# @login_required
def search_entries():
    try:
        searchword = request.form['searchword']
    except:
        searchword = ""

    # per_page = 20
    # search = False
    # q = request.args.get('q')
    # if q:
    #     search = True
    # name = request.args.get('name', '')
    # page = request.args.get(get_page_parameter(), type=int, default=1)
    # p = User.query.filter((User.name.like('%' + name + '%')) | (not name)).order_by(User.username.asc()).paginate(page,perpage)
    # entries = Entry.query.filter((Entry.title.like('%' + searchword + '%'))).order_by(Entry.id.desc())
    entries = Entry.query.filter(or_(
        (Entry.title.like('%' + searchword + '%')),
        (Entry.description.like('%' + searchword + '%')),
        (Entry.publisher.like('%' + searchword + '%')),
        (Entry.publisheddate.like('%' + searchword + '%')),
        (Entry.identifier10.like('%' + searchword + '%')),
        (Entry.identifier13.like('%' + searchword + '%')),
        (Entry.tanto.like('%' + searchword + '%')),
        (Entry.hokan.like('%' + searchword + '%')),
        (Entry.memo.like('%' + searchword + '%')),
    )).order_by(Entry.id.desc())
    # return render_template( 'user.html', pagination=p,name=name)
    # pagination = Pagination(page=page, total=3, search=search, record_name='entries')
    # return render_template('entries/index.html', entries=entries, pagination=pagination)
    return render_template('entries/index.html', entries=entries)
    # pagination = Pagination(page=page, total=entries.count(), search=search, record_name='entries', css_framework='foundation', **kwargs)



@entry.route('/alllist')
@login_required
def show_alllist():
    entries = Entry.query.all()
    return render_template('entries/alllist.html', entries=entries)


@entry.route('/entries', methods=['POST'])
@login_required
def add_entry():
    try:
        entry = Entry(
                title=request.form['title'],
                description=request.form['description'],
                publisher=request.form['publisher'],
                publisheddate=request.form['publisheddate'],
                identifier10=request.form['identifier10'],
                identifier13=request.form['identifier13'],
                thumbnail=request.form['thumbnail'],
                previewlink=request.form['previewlink'],
                tanto=request.form['tanto'],
                hokan=request.form['hokan'],
                memo=request.form['memo'],
                )
        db.session.add(entry)
        db.session.commit()
        flash('書籍情報が登録されました', 'alert alert-info')
        return redirect(url_for('entry.show_entries'))
    except:
        flash('エラーが発生しました (同じタイトルの書籍がすでに登録されているかもしれません)', 'alert alert-danger')
        return redirect(url_for('entry.show_entries'))

@entry.route('/entries/get_isbn', methods=['POST'])
@login_required
def get_isbn():
    isbn = request.form['getisbn']
    url = 'https://www.googleapis.com/books/v1/volumes?q=isbn:'
    isbn_path = "./isbn_data/" + isbn + ".json"
    titlevalue = ""
    descriptionvalue = ""
    publishervalue = ""
    publisheddatevalue = ""
    identifier10value = ""
    identifier13value = ""
    thumbnailvalue = ""
    previewlinkvalue = ""
    try:
        with open(isbn_path, 'r') as f:
            data = json.load(f)
            try:
                titlevalue += data['items'][0]['volumeInfo']['title']
                try:
                    descriptionvalue += data['items'][0]['volumeInfo']['description']
                except:
                    # flash('概要を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publishervalue += data['items'][0]['volumeInfo']['authors'][0]
                except:
                    # flash('発行者を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publisheddatevalue += data['items'][0]['volumeInfo']['publishedDate']
                except:
                    # flash('発行日を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier'] == isbn:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-10を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier'] == isbn:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-13を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    thumbnailvalue += data['items'][0]['volumeInfo']['imageLinks']['thumbnail']
                except:
                    # flash('サムネイルを参照できませんでした', 'alert alert-danger')
                    thumbnailvalue += ""
                    # pass
                try:
                    previewlinkvalue += data['items'][0]['volumeInfo']['previewLink']
                except:
                    # flash('プレビューを参照できませんでした', 'alert alert-danger')
                    pass
                flash('書籍情報を参照しました', 'alert alert-info')
            except:
                flash('書籍情報を参照できませんでした', 'alert alert-danger')


    except:
        req_url = url + isbn
        response = requests.get(req_url)
        with open(isbn_path, 'w') as f:
            json.dump(response.json(), f)
        with open(isbn_path, 'r') as f:
            data = json.load(f)
            try:
                titlevalue += data['items'][0]['volumeInfo']['title']
                try:
                    descriptionvalue += data['items'][0]['volumeInfo']['description']
                except:
                    # flash('概要を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publishervalue += data['items'][0]['volumeInfo']['authors'][0]
                except:
                    # flash('発行者を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publisheddatevalue += data['items'][0]['volumeInfo']['publishedDate']
                except:
                    # flash('発行日を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier'] == isbn:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-10を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier'] == isbn:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-13を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    thumbnailvalue += data['items'][0]['volumeInfo']['imageLinks']['thumbnail']
                except:
                    # flash('サムネイルを参照できませんでした', 'alert alert-danger')
                    thumbnailvalue += ""
                    # pass
                try:
                    previewlinkvalue += data['items'][0]['volumeInfo']['previewLink']
                except:
                    # flash('プレビューを参照できませんでした', 'alert alert-danger')
                    pass
                flash('書籍情報を参照しました', 'alert alert-info')
            except:
                flash('書籍情報を参照できませんでした', 'alert alert-danger')


    return render_template('entries/new.html',
        titlevalue=titlevalue,
        descriptionvalue=descriptionvalue,
        publishervalue=publishervalue,
        publisheddatevalue=publisheddatevalue,
        identifier10value=identifier10value,
        identifier13value=identifier13value,
        thumbnailvalue=thumbnailvalue,
        previewlinkvalue=previewlinkvalue)

@entry.route('/entries/new', methods=['GET'])
@login_required
def new_entry():
    return render_template('entries/new.html')

@entry.route('/entries/<int:id>', methods=['GET'])
@login_required
def show_entry(id):
    entry = Entry.query.get(id)
    return render_template('entries/show.html', entry=entry)


@entry.route('/entries/<int:id>/edit', methods=['GET'])
@login_required
def edit_entry(id):
    entry = Entry.query.get(id)
    return render_template('entries/edit.html', entry=entry)

flask_book/views/views.py
from flask import request, redirect, url_for, render_template, flash, session
from flask_book import app
from functools import wraps


def login_required(view):
    @wraps(view)
    def inner(*args, **kwargs):
        if not session.get('logged_in'):
            # return redirect(url_for('/'))
            return redirect(url_for('login'))
        return view(*args, **kwargs)
    return inner


@app.route('/login', methods=['GET', 'POST'])
def login():
    error = None
    if request.method == 'POST':
        if request.form['username'] != app.config['USERNAME']:
            flash('ユーザ名が異なります', 'alert alert-danger')
        elif request.form['password'] != app.config['PASSWORD']:
            flash('パスワードが異なります', 'alert alert-danger')
        else:
            session['logged_in'] = True
            # flash('ログインしました', 'alert alert-info')
            return redirect(url_for('entry.show_entries'))
    return render_template('login.html')


@app.route('/logout')
def logout():
    session.pop('logged_in', None)
    flash('ログアウトしました', 'alert alert-info')
    return redirect(url_for('entry.show_entries'))

@app.route('/readme')
def readme():
    return render_template('readme.html')

@app.errorhandler(404)
def non_existant_route(error):
   return redirect(url_for('login'))

flask_book/templates/entries/alllist.html
{% extends "layout.html" %}

{% block body %}

    <div>
    <!-- <div table-responsive> -->
    <table class="table table-bordered table-condensed table-sm">
        <thead>
            <tr>
                <th scope="col">ID</th>
                <th width=200>タイトル</th>
                <th width=200>発行者</th>
                <th width=200>発行日</th>
                <th width=200>ISBN10</th>
                <th width=200>ISBN13</th>
                <th width=200>担当者</th>
                <th width=200>保管場所</th>
                <th width=200>メモ</th>
                <th width=600>概要</th>
            </tr>
        </thead>
        <tbody>
            {% for entry in entries %}
            <tr>
                <td>{{ entry.id }}</td>
                <td>{{ entry.title }}</td>
                <td>{{ entry.publisher }}</td>
                <td>{{ entry.publisheddate }}</td>
                <td>{{ entry.identifier10 }}</td>
                <td>{{ entry.identifier13 }}</td>
                <td>{{ entry.tanto }}</td>
                <td>{{ entry.hokan }}</td>
                <td>{{ entry.memo }}</td>
                <td>{{ entry.description }}</td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
    </div>

{% endblock %}

flask_book/templates/entries/edit.html
{% extends "layout.html" %}
{% block body %}

<form action="{{ url_for('entry.update_isbn', id=entry.id) }}" method=post class=update-isbn>
    <div class="form-group col-sm-9">
        <p>必要に応じてISBNコードを入力して書籍参照のうえ更新をお願いします。</p>
    </div>
    <div class="form-group col-sm-3">
        <label for="UpdateIsbn">ISBNコード</label>
        <input type="number" pattern="\d*" class="form-control" id="UpdateIsbn" name=updateisbn value={{ entry.identifier13 }} required>
    </div>
    <div class="form-group col-sm-2">
        <button type="submit" class="btn btn-primary">書籍参照</button>
    </div>
    <hr/>
</form>



<!-- <div class="btn-group" col-sm-7> -->

    {% if titlevalue %}

    <form action="{{ url_for('entry.update_entry', id=entry.id) }}" method=post class=add-entry>
        <div class="form-group col-sm-7">
            <label for="InputTitle">書籍名</label>
            <input type="text" class="form-control" id="InputTitle" name=title value={{ titlevalue }}>
        </div>
        <div class="form-group col-sm-7">
            <label for="InputDescription">概要</label>
            <textarea class="form-control" id="InputDescription" name=description rows="4">{{ descriptionvalue }}</textarea>

        </div>
        <div class="form-group col-sm-2">
            <label for="InputPublisher">発行者</label>
            <input type="text" class="form-control" id="InputPublisher" name=publisher value={{ publishervalue }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="InputPublisheddate">発行年</label>
            <input type="text" class="form-control" id="InputPublishedDate" name=publisheddate value={{ publisheddatevalue }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="InputIdentifier10">ISBN-10</label>
            <input type="text" class="form-control" id="InputIdentifier10" name=identifier10 value={{ identifier10value }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="InputIdentifier13">ISBN-13</label>
            <input type="text" class="form-control" id="InputIdentifier13" name=identifier13 value={{ identifier13value }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="tanto">担当者</label>
            <input type="text" class="form-control" id="tanto" name=tanto value={{ entry.tanto }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="hokan">保管場所</label>
            <select class="form-control" id="hokan" name=hokan>
                {% if entry.hokan == "書籍棚" %}
                    <option selected>書籍棚</option>
                    <option>自席</option>
                    <option >その他</option>
                {% elif entry.hokan == "自席" %}
                    <option>書籍棚</option>
                    <option selected>自席</option>
                    <option>その他</option>
                {% else %}
                    <option>書籍棚</option>
                    <option>自席</option>
                    <option selected>その他</option>
                {% endif %}
            </select>
        </div>
        <div class="form-group col-sm-7">
            <label for="memo">メモ</label>
            <textarea class="form-control" id="memo" name=memo rows="4">{{ entry.memo }}</textarea>
        </div>
        <div class="form-group col-sm-7">
            <label for="InputThumbnail">サムネイル</label>
            <input type="text" class="form-control" id="InputThumbnail" name=thumbnail value={{ thumbnailvalue }}>
        </div>
        <div class="form-group col-sm-7">
            <label for="InputPreviewlink">プレビュー</label>
            <input type="text" class="form-control" id="InputPreviewLink" name=previewlink value={{ previewlinkvalue }}>
        </div>
        <div class="form-group col-sm-2">
            <button type="submit" class="btn btn-primary">更新</button>
        </div>
    </form>

    {% else %}

    <form action="{{ url_for('entry.update_entry', id=entry.id) }}" method=post class=add-entry>
        <div class="form-group col-sm-7">
            <label for="InputTitle">書籍名</label>
            <input type="text" class="form-control" id="InputTitle" name=title value={{ entry.title }}>
        </div>
        <div class="form-group col-sm-7">
            <label for="InputDescription">概要</label>
            <textarea class="form-control" id="InputDescription" name=description rows="4">{{ entry.description }}</textarea>

        </div>
        <div class="form-group col-sm-2">
            <label for="InputPublisher">発行者</label>
            <input type="text" class="form-control" id="InputPublisher" name=publisher value={{ entry.publisher }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="InputPublisheddate">発行年</label>
            <input type="text" class="form-control" id="InputPublishedDate" name=publisheddate value={{ entry.publisheddate }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="InputIdentifier10">ISBN-10</label>
            <input type="text" class="form-control" id="InputIdentifier10" name=identifier10 value={{ entry.identifier10 }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="InputIdentifier13">ISBN-13</label>
            <input type="text" class="form-control" id="InputIdentifier13" name=identifier13 value={{ entry.identifier13 }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="tanto">担当者</label>
            <input type="text" class="form-control" id="tanto" name=tanto value={{ entry.tanto }}>
        </div>
        <div class="form-group col-sm-2">
            <label for="hokan">保管場所</label>
            <select class="form-control" id="hokan" name=hokan>
                {% if entry.hokan == "書籍棚" %}
                    <option selected>書籍棚</option>
                    <option>自席</option>
                    <option >その他</option>
                {% elif entry.hokan == "自席" %}
                    <option>書籍棚</option>
                    <option selected>自席</option>
                    <option>その他</option>
                {% else %}
                    <option>書籍棚</option>
                    <option>自席</option>
                    <option selected>その他</option>
                {% endif %}
            </select>
        </div>
        <div class="form-group col-sm-7">
            <label for="memo">メモ</label>
            <textarea class="form-control" id="memo" name=memo rows="4">{{ entry.memo }}</textarea>
        </div>
        <div class="form-group col-sm-7">
            <label for="InputThumbnail">サムネイル</label>
            <input type="text" class="form-control" id="InputThumbnail" name=thumbnail value={{ entry.thumbnail }}>
        </div>
        <div class="form-group col-sm-7">
            <label for="InputPreviewlink">プレビュー</label>
            <input type="text" class="form-control" id="InputPreviewLink" name=previewlink value={{ entry.previewlink }}>
        </div>
        <div class="form-group col-sm-2">
            <button type="submit" class="btn btn-primary">更新</button>
        </div>
        <!-- <div class="form-group col-sm-7">
            投稿日時 {{ entry.created_at }}
        </div> -->
    </form>
    {% endif %}

    <hr>

    <form action="{{ url_for('entry.delete_entry', id=entry.id) }}" method="post">
        <div class="form-group col-sm-2">
            <button type="submit" class="btn btn-danger">削除</button>
        </div>
        <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
        <script type="text/javascript">
            $(function(){
                $(".btn-danger").on('click', function(){
                if(window.confirm("削除しますがよろしいですか？")) {
                location.href = $(this).attr('href');
                } else {
                    return false;
                }
            });
        });
        </script>
    </form>

<!-- </div> -->

{% endblock %}

flask_book/templates/entries/index.html
{% extends "layout.html" %}

{% block body %}

<script type="text/javascript">
    $(function () {
      $('[data-toggle="tooltip"]').tooltip();
    })
</script>


    <div table-responsive>
    <table id="myTable" class="table table-hover table-sm">
        <thead>
        <tr>
            <th scope="col">ID</th>
            <th>表紙</th>
            <th>タイトル</th>
            <th>書籍情報</th>
            <!-- <th>ISBN</th> -->
            <!-- <th>概要</th> -->
        </tr>
        </thead>
        <tbody>
            {% for entry in entries %}
            <tr>
                <td scope="row"><a href="{{ url_for('entry.edit_entry', id=entry.id) }}">{{ entry.id }}</a>
                {% if entry.created_at %}
                <br><img src="/static/new.gif"></img>
                {% else %}
                {% endif %}
                </td>
                <td>
                {% if entry.thumbnail == "" %}
                    <a href="{{ entry.previewlink }}" data-toggle="tooltip" data-placement="right" data-original-title="{{ entry.description }}"><img width=120 src="/static/noimage.jpg"</img></a>
                {% else %}
                    <a href="{{ entry.previewlink }}" data-toggle="tooltip" data-placement="right" data-original-title="{{ entry.description }}"><img src="{{ entry.thumbnail }}"></img></a>
                {% endif %}
                </td>


                <td>{{ entry.title }}</td>
                <td>発行者：{{ entry.publisher }}<br>
                    発行日：{{ entry.publisheddate }}<br>
                    ISBN10：<a href="https://www.amazon.co.jp/dp/{{ entry.identifier10 }}">{{ entry.identifier10 }}</a><br>
                    ISBN13：<a href="https://www.amazon.co.jp/dp/{{ entry.identifier10 }}">{{ entry.identifier13 }}</a><br>
                    担当者：{{ entry.tanto }}<br>
                    保管場所：{{ entry.hokan }}<br>
                    メモ：{{ entry.memo }}<br><td>
                <!-- <td>{{ entry.description }}</td> -->
            </tr>
            {% endfor %}
        </tbody>
    </table>
    </div>

{% endblock %}

flask_book/templates/entries/new.html
{% extends "layout.html" %}
{% block body %}
<form action="{{ url_for('entry.get_isbn') }}" method=post class=get-isbn>
    <div class="form-group col-sm-6">
        <p>ISBNコードを入力して書籍参照のうえ登録をお願いします。</p>
    </div>
    <div class="form-group col-sm-3">
        <label for="GetIsbn">ISBNコード</label>
        <input type="number" pattern="\d*" class="form-control" id="GetIsbn" name=getisbn value="9784" required>
    </div>
    <div class="form-group col-sm-2">
        <button type="submit" class="btn btn-primary">書籍参照</button>
    </div>
    <hr/>
</form>

<form action="{{ url_for('entry.add_entry') }}" method=post class=add-entry>
    <div class="form-group col-sm-7">
        {% if thumbnailvalue == "" %}
        <img width=120 src="/static/noimage.jpg"</img>
        {% else %}
        <img src='{{ thumbnailvalue }}'>
        {% endif %}
    </div>
    <div class="form-group col-sm-7">
        <label for="InputTitle">書籍名(必須項目)</label>
        <input type="text" class="form-control" id="InputTitle" name=title value="{{ titlevalue }}" required>
    </div>
    <div class="form-group col-sm-7">
        <label for="InputDescription">概要</label>
        <textarea class="form-control" id="InputDescription" name=description rows="4">{{ descriptionvalue }}</textarea>
    </div>

    <div class="form-group col-sm-2">
        <label for="InputPublisher">発行者</label>
        <input type="text" class="form-control" id="InputPublisher" name=publisher value="{{ publishervalue }}">
    </div>
    <div class="form-group col-sm-2">
        <label for="InputPublisheddate">発行日</label>
        <input type="text" class="form-control" id="InputPublishedDate" name=publisheddate value="{{ publisheddatevalue }}">
    </div>
    <div class="form-group col-sm-2">
        <label for="InputIdentifier10">ISBN-10</label>
        <input type="text" class="form-control" id="InputIdentifier10" name=identifier10 value="{{ identifier10value }}">
    </div>
    <div class="form-group col-sm-2">
        <label for="InputIdentifier13">ISBN-13</label>
        <input type="text" class="form-control" id="InputIdentifier13" name=identifier13 value="{{ identifier13value }}">
    </div>
    <div class="form-group col-sm-2">
        <label for="tanto">担当者</label>
        <input type="text" class="form-control" id="tanto" name=tanto>
    </div>
    <div class="form-group col-sm-2">
        <label for="hokan">保管場所</label>
        <select class="form-control" id="hokan" name=hokan>
            <option>書籍棚</option>
            <option>自席</option>
            <option>その他</option>
        </select>
    </div>
    <div class="form-group col-sm-7">
        <label for="memo">メモ</label>
        <textarea class="form-control" id="memo" name=memo rows="4"></textarea>
    </div>
    <div class="form-group col-sm-7">
        <label for="InputThumbnail">サムネイル</label>
        <input type="text" class="form-control" id="InputThumbnail" name=thumbnail value="{{ thumbnailvalue }}">
    </div>
    <div class="form-group col-sm-7">
        <label for="InputPreviewlink">プレビュー</label>
        <input type="text" class="form-control" id="InputPreviewLink" name=previewlink value="{{ previewlinkvalue }}">
    </div>
    <div class="form-group col-sm-2">
        <button type="submit" class="btn btn-primary">登録</button>
    </div>
</form>

{% endblock %}

flask_book/templates/entries/show.html
{% extends "layout.html" %} {% block body %}

<div class="form-group col-sm-3">
    <h3>{{ entry.title }}</h3>
    <h5>{{ entry.publisher }}</h5>
    投稿日時 {{ entry.created_at }}
    <br>
    <br>

    <div class="btn-group">
        <form action="{{ url_for('entry.edit_entry', id=entry.id) }}" method="get">
            <button type="submit" class="btn btn-secondary">編集</button>
        </form>

        <form action="{{ url_for('entry.delete_entry', id=entry.id) }}" method="post">
            <button type="submit" class="btn btn-danger" style="margin-left:5px">削除</button>

            <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
            <script type="text/javascript">
                $(function(){
                    $(".btn-danger").on('click', function(){
                    if(window.confirm("削除しますがよろしいですか？")) {
                    location.href = $(this).attr('href');
                    } else {
                        return false;
                    }
                });
            });
            </script>

        </form>
    </div>
</div>

{% endblock %}